require "backupmypics/version"
require "open-uri"
require 'nokogiri'
require 'json'

module Backupmypics

  def self.fetch_user_data(user)
      doc = Nokogiri::HTML(open(URI("https://instagram.com/#{user}")))
      scripts = doc.css("body > script")[2].text
      JSON.parse(scripts[21..-2])["entry_data"]["ProfilePage"][0]
  end

  def self.extract_pictures(user_data)
      pictures = Array.new

      user_data["user"]["media"]["nodes"].each do |node|
          pictures.push({node["code"] => node["display_src"]})
      end

      if user_data["user"]["media"]["page_info"]["has_next_page"]
          return {:pictures => pictures, :next_id => user_data["user"]["media"]["page_info"]["end_cursor"]}
      end
      {:pictures => pictures, :next_id => nil}
  end
  
  def self.download(items)
    items[:pictures].each do |item|
      name = item.keys.first
      url = item.values.first

      Dir.chdir("#{Dir.home}/backupmypics")
      
      puts "Trying to save #{name} to #{Dir.home}/backupmypics"
      File.open("#{name}.jpg", "wb") do |fo|
        fo.write open(URI(url)).read
      end
    end
  end
end
